# -*- perl -*- ###############################################################
#
#  			Copyright 2006 <Dr. Detlef Groth>.
#
#  Object Name   : $RCSfile:$
#  Revision      : $Revision:$
#  Date          : $Date:$
#  Author        : $Author:$
#  Created By    : Dr. Detlef Groth
#  Created       : Tue Nov 28 15:08:24 2006
#  Last Modified : <061203.0751>
#
#  Description	
#
#  Notes
#
#  $Log: $
#	
##############################################################################

package AppCombineConsolePDF;
use Getopt::Long;
use strict ;
use FindBin;
use lib "$FindBin::Bin/../lib";
require CombinePDFs ;
my @infiles;
my $outfile;
my $overwrite = 0;
my $bookmarks ;
my @pages;
sub help {
    print STDERR "
    PDF-Prozessor Dr. Detlef Groth 2006
    No warranty of any kind!
    ========================================
    Usage: <perl> $0 
    --infile <pdffile>  --pages <n-n> 
    [--infile ... --pages ...]        
    --outfile <outfile.pdf> 
    [--bookmarks <bookmarksfile>]
    ========================================
    --pages might bei either 'from-to' or 'all'
    different ranges from the same file
    must be seperated with commas like so:
    '--pages 1-4,8-10'
    ";
    if ($#pages != $#infiles) {
        print STDERR "\n==================================\nError: Not the same number of --infile and --pages\n       options given on the commandline";
    }
    exit 0 ;
}
sub checkPages {
    my $x = 0 ;
    foreach my $p (@pages) {
        foreach my $pages (split(/,/,$p)) {
            if ($pages !~ m/^[0-9]+-[0-9]+$/ and $pages !~ m/^[0-9]+$/ and $pages ne "all") {
                print STDERR "Error: Invalid page definition for $infiles[$x] $p '$pages'!\n     Must be either 'from-to' or 'all'!\n" ;
                help;
            }
        }
        $x++ ;
    }
}
sub checkFiles {
    foreach my $file (@infiles) {
        if (!-r $file) {
            print STDERR "Error: File `$file' does not exists!\n" ;
            help;
        }
        if (!CombinePDFs::isPDF($file)) {
            print STDERR "Error: File `$file' is not an PDF-file!\n" ;
            help ;
        }
    }
    if (-e $outfile and !$overwrite) {
        print STDERR "Error: File `$outfile' already exists!\n Specify --overwrite on the command line to overwrite the existing file\n";
        exit 0 ;
    }
}
sub checkBookmarks {
    if ($bookmarks) {
        if (!-e $bookmarks) {
            print STDERR "Error: Bookmarksfile $bookmarks does not exists!\n" ;
            help;
        }
    }
}
sub main {
    GetOptions("infile=s" => \@infiles,
               "outfile=s" => \$outfile,
               "pages=s", => \@pages,
               'overwrite' => \$overwrite,
               'bookmarks:s' => \$bookmarks,
               'help' => \&help) ;
    help unless ((@infiles and $outfile and @pages) and $#pages == $#infiles);
    checkPages;
    checkFiles;
    checkBookmarks;
    CombinePDFs::createPDF(\@infiles,\@pages,$outfile,$bookmarks);
}
main();
exit 0;
